<template>
  <div class="card-app card shadow" :class="componentClass">
    <div class="card-body row g-0">
      <SvgMedium class="icon-app" :showLabel="false" :showIcon="true" />
      <SvgMedium class="label-app" :showLabel="true" :showIcon="false" />
      <!-- <div class="text-muted mt-3">Biggest online video sharing and social media platform.</div> -->
      <div class="label-user text-muted">{{ displayName }}</div>
      <div v-if="editting" class="mt-3 w-100">
        <div>
          To connect to Medium you have to enter Integration Token from Your
          Medium
          <a href="https://medium.com/me/settings#membership" target="_blank"
            >settings page</a
          >.
        </div>
        <textarea
          id="textarea-token"
          v-model="integrationToken"
          placeholder="Enter Medium Integration Token..."
          rows="3"
          class="mt-2 w-100"
        />
      </div>
      <button
        class="btn btn-connect"
        :class="[isActive ? 'btn-success' : 'btn-primary']"
        @click="OnBtnConnectClicked"
      ></button>
    </div>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import SvgMedium from "./SvgMedium.vue";
import PLATFORMS from "../enums/platforms";

export default {
  data() {
    return {
      editting: false,
      integrationToken: "",
    };
  },
  components: { SvgMedium },
  props: ["userName"],
  computed: {
    profiles() {
      return this.$store.state.profiles.list.filter(
        (p) => p.platform === PLATFORMS.MEDIUM
      );
    },
    isActive() {
      return this.profiles.length > 0;
    },
    displayName() {
      return this.profiles[0] ? this.profiles[0].displayName : "";
    },
    componentClass() {
      let cssClass = "";
      if (this.isActive) cssClass += "active";
      if (this.editting) cssClass += " editting";
      return cssClass;
    },
  },
  methods: {
    ...mapActions(["connectMedium", "disconnectProfile"]),
    async OnBtnConnectClicked() {
      if (this.editting && this.integrationToken) {
        await this.connectMedium(this.integrationToken);
        this.editting = false;
      } else {
        if (!this.isActive) {
          this.editting = true;
        }
        //disconnect
        else {
          await this.disconnectProfile(this.profiles[0].id);
        }
      }
    },
  },
};
</script>

<style lang="scss" scoped>
#textarea-token {
  resize: none;
}

@include media-breakpoint-up(sm) {
  .card-app.editting {
    grid-column: auto / span 2;
    grid-row: auto / span 2;
  }
}
</style>